%This Example for using users m-function supply_chain_function.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))
%Constraint: >= vector_l_scp, <= vector_u_scp
%linearmulti(pmatrix_xmulti_scp)
%Box: >= 0, <= 1e+13
%Solver: cargrb, precision = 6
%
%Input variables:
%
%Inputs                             PSG Type    PSG Object                    Location in Problem Statement                                                           Class
%matrix_xfirst_scp_data             data        matrix_xfirst_scp             avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%matrix_xfirst_scp_vars             vars        matrix_xfirst_scp             avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%matrix_of_scenarios_scp_75_data    data        matrix_of_scenarios_scp_75    avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%matrix_of_scenarios_scp_75_vars    vars        matrix_of_scenarios_scp_75    avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%pmatrix_subproblem_scp_data        data        pmatrix_subproblem_scp        avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%pmatrix_subproblem_scp_vars        vars        pmatrix_subproblem_scp        avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%pmatrix_xmulti_scp_data            data        pmatrix_xmulti_scp            linearmulti(pmatrix_xmulti_scp)                                                         double
%pmatrix_xmulti_scp_vars            vars        pmatrix_xmulti_scp            linearmulti(pmatrix_xmulti_scp)                                                         cell
%vector_l_scp_data                  data        vector_l_scp                  Constraint: >= vector_l_scp, <= vector_u_scp                                            double
%vector_u_scp_data                  data        vector_u_scp                  Constraint: >= vector_l_scp, <= vector_u_scp                                            double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('C:\Aorda\PSG\MATLAB\CS_Supply_Chain\supply_chain_function_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function supply_chain_function:

[solution_str,outargstruc_arr] = supply_chain_function(matrix_xfirst_scp_data,matrix_xfirst_scp_vars,matrix_of_scenarios_scp_75_data,matrix_of_scenarios_scp_75_vars,pmatrix_subproblem_scp_data,pmatrix_subproblem_scp_vars,pmatrix_xmulti_scp_data,pmatrix_xmulti_scp_vars,vector_l_scp_data,vector_u_scp_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data{1});

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
